Name:           ekeyd
Version:        1.1.4
Release:        3%{?dist}
Summary:        Simtec Electronics UDEKEY01 Entropy Key Daemon

Group:          System Environment/Daemons
License:        Copyright 2011 Simtec Electronics
URL:            http://www.simtec.co.uk/products/UDEKEY01/files/
Source0:        %{name}-%{version}.tar.gz
Source1:        ekeyd.init
Source2:        60-entropykey.rules
Patch0:		ekeyd-lua52-control.lua.diff
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildRequires:  lua, lua-devel, udev
Requires:       lua-socket
Requires(post): chkconfig
Requires(preun): chkconfig, initscripts
Requires(postun): initscripts

%description
Simtec Electronics UDEKEY01 Entropy Key Daemon
This is a driver for the Simtec Electronics Entropy Key.  It is
only needed if you have such a device (or devices).  It provides
a daemon and tools to drive and control it, as well as options
for injecting entropy directly into the kernel's pool, or serving
it via the EGD protocol.

%package egd-linux
Summary:        EGD to Linux Kernel pool top-up daemon
Group:          System Environment/Daemons

%description egd-linux
EGD (Entropy Gathering Daemon) created a de-facto standard for
the distribution of entropy (random data) over a socket.  This
daemon connects to another daemon which implements the same
protocol as EGD (such as ekeyd) and then injects entropy into
the Linux kernel random pool.

%prep
%setup -q
%patch0 -p1

%build
cd host
# Lua binary has no version on these distros...
make LUA_V='' BUILD_ULUSBD=no

%install
rm -rf $RPM_BUILD_ROOT
# build the main code
cd host
make install BUILD_ULUSBD=no DESTDIR=${RPM_BUILD_ROOT}
cd ..
#Install udev
mkdir -p ${RPM_BUILD_ROOT}/lib/udev
cp udev/entropykey.sh ${RPM_BUILD_ROOT}/lib/udev/entropykey.sh
mkdir -p ${RPM_BUILD_ROOT}/etc/udev/rules.d/
cp %SOURCE2 ${RPM_BUILD_ROOT}/etc/udev/rules.d/60-entropykey.rules
# Put the init script in place
mkdir -p ${RPM_BUILD_ROOT}%{_initrddir}
install -m 755 %SOURCE1 ${RPM_BUILD_ROOT}%{_initrddir}/ekeyd
%clean
rm -rf ${RPM_BUILD_ROOT}


%files
%defattr(-,root,root,-)
%doc doc/README doc/README.security doc/README.protocol
%config(noreplace) %{_sysconfdir}/entropykey/ekeyd.conf
%config(noreplace) %{_sysconfdir}/entropykey/keyring
%{_sbindir}/ekey-rekey
%{_sbindir}/ekey-setkey
%{_sbindir}/ekeyd
%{_sbindir}/ekeydctl
%{_mandir}/man5/ekeyd.conf.5.gz
%{_mandir}/man8/ekey-rekey.8.gz
%{_mandir}/man8/ekey-setkey.8.gz
%{_mandir}/man8/ekeyd.8.gz
%{_mandir}/man8/ekeydctl.8.gz
%{_initrddir}/ekeyd
/lib/udev/entropykey.sh
/etc/udev/rules.d/60-entropykey.rules

%files egd-linux
%defattr(-,root,root,-)
%doc doc/README.egd-linux doc/README.egd-protocol
%{_sbindir}/egd-linux
%{_mandir}/man8/egd-linux.8.gz

%post

/sbin/chkconfig --add ekeyd

if test -x /sbin/udevcontrol; then
    udevcontrol --reload_rules >/dev/null 2>&1 || udevcontrol reload_rules >/dev/null 2>&1
elif test -x /sbin/udevadm; then
    udevadm control --reload-rules >/dev/null 2>&1 || udevadm control --reload_rules >/dev/null 2>&1
fi

/sbin/service ekeyd start >/dev/null 2>&1 || true

%preun
if [ $1 = 0 ] ; then
  /sbin/service ekeyd stop >/dev/null 2>&1
  /sbin/chkconfig --del ekeyd
fi

%postun
if [ "$1" -ge "1" ] ; then
  /sbin/service ekeyd condrestart >/dev/null 2>&1 || :
fi

if test -x /sbin/udevcontrol; then
    udevcontrol --reload_rules >/dev/null 2>&1 || udevcontrol reload_rules >/dev/null 2>&1
elif test -x /sbin/udevadm; then
    udevadm control --reload-rules >/dev/null 2>&1 || udevadm control --reload_rules >/dev/null 2>&1
fi

%changelog
* Tue Mar  4 2014 Jon Jensen <jon@endpoint.com> 1.1.4-3
- Rebuilt for Fedora 20.
- Adapt control.lua to work with Lua 5.2.
* Wed Jul 18 2012 Jon Jensen <jon@endpoint.com> 1.1.4-2
- Remove BUS=="USB" rule which udev no longer recognizes.
- Clean up spec file a bit.
- Rebuilt for Fedora 17.
* Fri Nov 18 2011 Jon Jensen <jon@endpoint.com> 1.1.4-1
- Rebuilt for Fedora 16.
* Mon Jul 25 2011 Rob Kendrick <rjek@simtec.co.uk> 1.1.4-1
- New upstream release
- Improved udev rules by Vincent Sanders
* Mon Sep 06 2010 Daniel Silverstone <dsilvers@debian.org> 1.1.3-1
- New upstream release
* Tue Nov 17 2009 Daniel Silverstone <dsilvers@debian.org> 1.1.1-1
- New upstream release
* Mon Nov 09 2009 Daniel Silverstone <dsilvers@debian.org> 1.1.0-1
- New upstream release
* Thu Oct 15 2009 Daniel Silverstone <dsilvers@debian.org> 1.0.7-1
- New upstream release
* Tue Sep 15 2009 Daniel Silverstone <dsilvers@debian.org> 1.0.5-1
- New upstream release
* Tue Aug 25 2009 Daniel Silverstone <dsilvers@debian.org> 1.0-1
- Initial upstream release
